<?php

if (!function_exists("custom_popups_frontend_script_init")) {
function custom_popups_frontend_script_init(){
 	wp_register_script('custom_popups_frontend_script_reveal', plugins_url( '/reveal/jquery.reveal.js', __FILE__ ), array( 'jquery'), '1', false );
 	wp_enqueue_script('custom_popups_frontend_script_reveal');
 	wp_register_script('custom_popups_frontend_script_cookie', plugins_url( '/js/jquery.cookie.js', __FILE__ ), array( 'jquery'), '1', false );
 	wp_enqueue_script('custom_popups_frontend_script_cookie');
}
add_action('wp_enqueue_scripts', 'custom_popups_frontend_script_init');
}

if (!function_exists("custom_popups_frontend_style_init")) {
function custom_popups_frontend_style_init(){
	wp_register_style('custom_popups_frontend_style_reveal', plugins_url( '/reveal/reveal.css', __FILE__ ), array(), '1', 'screen');
	wp_enqueue_style('custom_popups_frontend_style_reveal');
}
add_action('wp_enqueue_scripts', 'custom_popups_frontend_style_init');
}

function custom_popups_frontend_popup_html(){
	global $wpdb;
	$table_name = "wp_popup_plugin_content";
	
	global $blog_id;
	if(!$blog_id){
		$blog_id = 'no_id';
	}
	
	$content = '';
	$content_id = null;
	if(isset($_GET['popup_preview'])){
		$popup = $wpdb->get_row("SELECT * FROM $table_name WHERE id = ".intval($_GET['popup_preview'])." ORDER BY id DESC LIMIT 0,1");
		if($popup){
			$content = $popup->content;
			$content_width = $popup->width;
			$content_animation = $popup->animation;
		}
	}else{
		$popups = $wpdb->get_results("SELECT * FROM $table_name WHERE blog_id = '$blog_id' AND status = 'published' ORDER BY RAND()");
		$i = 0;
		while($i < count($popups)){
			if(strtotime($popups[$i]->stop_date) > 1 AND $popups[$i]->stop_date AND time() > strtotime($popups[$i]->stop_date)){
				$wpdb->update($table_name, array('status'=>'inactive'), array('id'=>intval($popups[$i]->id)), array("%s"));
				unset($popups[$i]);
			}else{
				if($popups[$i]->pages_to_display_on == 'specific_pages'){
					$popup_urls_array = explode(';',preg_replace('/\s+/', '', $popups[$i]->urls));
					if(!in_array(CurrentUrl(), $popup_urls_array)){
						unset($popups[$i]);
					}
				}
			}
			$i++;
		}
		
		if(!$popups){
			return null;
		}
		
		$cookie_name_1 = $wpdb->base_prefix . 'popup_plugin_views';
		$cookie_name_2 = $wpdb->base_prefix . 'popup_plugin_dontshow';
		$cookie_name_3 = $wpdb->base_prefix . 'popup_plugin_total';
		$cookie_name_4 = $wpdb->base_prefix . 'popup_plugin_x_per';
		if(Cookie::Exists($cookie_name_3)){
			$total = Cookie::Get($cookie_name_3);
		}else{
			$total = 1;
		}
		
		if(Cookie::Exists($cookie_name_2)){
			$banned = explode(",", Cookie::Get($cookie_name_2));
			$i = 0;
			while($i < count($popups)){
				if(in_array($popups[$i]->id, $banned)){
					unset($popups[$i]);
				}
				$i++;
			}
		}
		
		if(!$popups){
			return null;
		}
		
		$displayed = array();
		$x_per = array();
		$displayed_id = null;
		$done = false;
		
		if(!Cookie::Exists($cookie_name_1)){
			$content = $popups[0]->content;
			$content_id = $popups[0]->id;
			$content_width = $popups[0]->width;
			$content_animation = $popups[0]->animation;
			$displayed[intval($popups[0]->id)] = 1;
			$done = true;
		}
		
		if(Cookie::Exists($cookie_name_1) AND $done == false){
			$displayed = unserialize(stripcslashes(Cookie::Get($cookie_name_1)));
			foreach($popups as $p){
				if(!isset($displayed[$p->id])){
					$content = $p->content;
					$content_width = $p->width;
					$content_animation = $p->animation;
					$displayed[intval($p->id)] = 1;
					$done = true;
					break;
				}
			}
			
			if(!$done){
				$i = 0;
				while($i < count($popups)){
					if($popups[$i]->regularity_type == 'only_once' AND isset($displayed[$p->id])){
						unset($popups[$i]);
					}
					$i++;
				}
			}
		}
		
		if(Cookie::Exists($cookie_name_4) AND $done == false){
			$x_per = unserialize(stripcslashes(Cookie::Get($cookie_name_4)));
			$i = 0;
			while($i < count($popups)){
				if($popups[$i]->regularity_type == 'x_per'){
					
					if($popups[$i]->regularity_period == 'month'){
						$regularity_period = date('n');
					}elseif($popups[$i]->regularity_period == 'week'){
						$regularity_period = date('W');
					}else{
						$regularity_period = date('z');
					}
					
					if(!isset($x_per[$popups[$i]->id])){
						$content = $popups[$i]->content;
						$content_width = $popups[$i]->width;
						$content_animation = $popups[$i]->animation;
						$displayed[intval($popups[$i]->id)] = 1;
						$x_per[$popups[$i]->id] = array('count'=>1,'period'=>$regularity_period,'year'=>date('Y'));
						$done = true;
						break;
					}else{
						if($x_per[$popups[$i]->id]['period'] == $regularity_period AND $x_per[$popups[$i]->id]['year'] == date('Y')){
							if($x_per[$popups[$i]->id]['count'] >= intval($popups[$i]->regularity)){
								unset($popups[$i]);
							}
						}else{
							$content = $popups[$i]->content;
							$content_width = $popups[$i]->width;
							$content_animation = $popups[$i]->animation;
							$displayed[intval($popups[$i]->id)] = 1;
							$x_per[$popups[$i]->id]['count'] = 1;
							$x_per[$popups[$i]->id]['period'] = $regularity_period;
							$x_per[$popups[$i]->id]['year'] = date('Y');
							$done = true;
							break;
						}
					}
				}
				$i++;
			}
		}
		
		//sort out x_per	
				
		if(!$done){
					
			$difference = array();
			foreach($popups as $p){
				if($p->regularity_type != 'x_per'){
					$difference[intval($p->id)] = intval($p->regularity) - ceil(100 * (intval($displayed[intval($p->id)]) / $total));
				}
			}
					
			arsort($difference);
			reset($difference);
			$to_show = key($difference);
			foreach($popups as $p){
				if($p->regularity_type == 'x_per'){
					if($p->regularity_period == 'month'){
						$regularity_period = date('n');
					}elseif($p->regularity_period == 'week'){
						$regularity_period = date('W');
					}else{
						$regularity_period = date('z');
					}
					
					$content = $p->content;
					$content_width = $p->width;
					$content_animation = $p->animation;
					$displayed[intval($p->id)] = 1;
					$x_per[$p->id]['count'] = $x_per[$p->id]['count'] + 1;
					$x_per[$p->id]['period'] = $regularity_period;
					$x_per[$p->id]['year'] = date('Y');
					break;
				}else{
					if(intval($p->id) == $to_show AND $difference[$to_show] > 0){
						$content = $p->content;
						$content_id = $p->id;
						$content_width = $p->width;
						$content_animation = $p->animation;
						$displayed[intval($p->id)] = intval($displayed[intval($p->id)]) + 1;
						break;
					}
				}
			}
		}
			
		
		$total = $total + 1;
	}
	
	if($content){
	?>
	<?php
		$content_width_class = '';
		if($content_width){
			switch(intval($content_width)){
    				case 200:
        				$content_width_class = ' small';
        				break;
        			case 400:
        				$content_width_class = ' medium';
        				break;
        			case 600:
        				$content_width_class = ' large';
        				break;
        			case 800:
        				$content_width_class = ' xlarge';
        				break;
    				default:
       					$content_width_class = '';
			}
		}
	?>
<div id="popups_Modal" class="reveal-modal<?php echo $content_width_class;?>">
<div class="reveal-modal-content"><?php echo do_shortcode(@trim($content));?></div>
<a style="float: right;" class="reveal-btn close-reveal-modal blue" title="<?php echo __('Close','wp_popup_plugin') ?>"><?php echo __('Close','wp_popup_plugin') ?></a>
<a style="float: 'left';"class="reveal-modal-never reveal-btn"><?php echo __('Don\'t show again','wp_popup_plugin') ?></a>
<div style="clear:both"></div>
</div>
	<?php
		$content_animation_js = '';
		if($content_animation){
			$content_animation_js = "{animation: '$content_animation'}";
		}
	?>
<script type="text/javascript">
jQuery(document).ready(function($) {
	$('#popups_Modal').reveal(<?php echo $content_animation_js;?>);
	$('.close-reveal-modal').click(function(e){
		e.preventDefault();
		$('.reveal-modal-content').empty();
	});
	<?php if(!isset($_GET['popup_preview'])){?>
	$.cookie("<?php echo $cookie_name_1 ?>", "<?php echo addslashes(serialize($displayed)) ?>", { expires: 365, path: '/'});
	$.cookie("<?php echo $cookie_name_4 ?>", "<?php echo addslashes(serialize($x_per)) ?>", { expires: 365, path: '/'});
	$('.reveal-modal-never').click(function(e){
		e.preventDefault();
		$('.reveal-modal-content').empty();
		if($.cookie("<?php echo $cookie_name_2 ?>")){
			var stopped_popups = $.cookie("<?php echo $cookie_name_2 ?>") + "," + "<?php echo $content_id ?>";
			$.cookie("<?php echo $cookie_name_2 ?>", stopped_popups, { expires: 365, path: '/'});
		}else{
			$.cookie("<?php echo $cookie_name_2 ?>", "<?php echo $content_id ?>", { expires: 365, path: '/'});
		}
		$('#popups_Modal').trigger('reveal:close');
	});
    $(document).live('reveal:close', function(e) {
        $('.reveal-modal-content').empty();
    });
	<?php }?>
});
</script>
	<?php
	}
	if(!isset($_GET['popup_preview'])){
	?>
<script type="text/javascript">
jQuery(document).ready(function($) {
	$.cookie("<?php echo $cookie_name_3 ?>", "<?php echo $total ?>", { expires: 365, path: '/'});
});
</script>
	<?php
	}
}
add_action('wp_footer', 'custom_popups_frontend_popup_html', 100);
